//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39AECD940183.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39AECD940183.cm

//## begin module%39AECD940183.cp preserve=no
//## end module%39AECD940183.cp

//## Module: SpectralData%39AECD940183; Package specification
//## Subsystem: XSModel::Data%367691B49E40
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSModel/Data/SpectralData.h

#ifndef SPECTRALDATA_H
#define SPECTRALDATA_H 1

//## begin module%39AECD940183.additionalIncludes preserve=no
//## end module%39AECD940183.additionalIncludes

//## begin module%39AECD940183.includes preserve=yes
//## end module%39AECD940183.includes

// xsTypes
#include <main/xsTypes.h>
// valarray
#include <valarray>
// ctype
#include <ctype.h>
// Error
#include <XSUtil/Error/Error.h>
// Memento
#include <XSModel/GlobalContainer/Memento.h>

class Response;
class UserDummyResponse;

//## begin module%39AECD940183.declarations preserve=no
//## end module%39AECD940183.declarations

//## begin module%39AECD940183.additionalDeclarations preserve=yes
class BackCorr;
class DataSet;
typedef BackCorr Background;
typedef BackCorr Correction;
#include <XSUtil/Utils/XSstream.h>
//## end module%39AECD940183.additionalDeclarations


//## begin SpectralData%39AECD390243.preface preserve=yes
//## end SpectralData%39AECD390243.preface

//## Class: SpectralData%39AECD390243
//## Category: XSModel::Data%36349D4100F3
//## Subsystem: XSModel::Data%367691B49E40
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3E6E5EC2011D;UserDummyResponse { -> F}
//## Uses: <unnamed>%3E8C613C00A8;XSparse { -> }

class SpectralData 
{
  //## begin SpectralData%39AECD390243.initialDeclarations preserve=yes
  //## end SpectralData%39AECD390243.initialDeclarations

  public:
    //## Class: NoEnergyRange%3BDDB8F203C4
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class NoEnergyRange : public YellowAlert  //## Inherits: <unnamed>%3BDDB9B601EC
    {
      public:
        //## Constructors (specified)
          //## Operation: NoEnergyRange%3BDDB9160288
          NoEnergyRange (int spectrumNumber);

      protected:
      private:
      private: //## implementation
    };

    //## begin SpectralData::FluxCalc%412381220124.preface preserve=yes
    //## end SpectralData::FluxCalc%412381220124.preface

    //## Class: FluxCalc%412381220124
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct FluxCalc 
    {
      //## begin SpectralData::FluxCalc%412381220124.initialDeclarations preserve=yes
      //## end SpectralData::FluxCalc%412381220124.initialDeclarations

        // Data Members for Class Attributes

          //## Attribute: value%4123819C030E
          //## begin SpectralData::FluxCalc::value%4123819C030E.attr preserve=no  public: Real {U} 
          Real value;
          //## end SpectralData::FluxCalc::value%4123819C030E.attr

          //## Attribute: errLow%412381D601C2
          //## begin SpectralData::FluxCalc::errLow%412381D601C2.attr preserve=no  public: Real {U} 
          Real errLow;
          //## end SpectralData::FluxCalc::errLow%412381D601C2.attr

          //## Attribute: errHigh%412381F202AE
          //## begin SpectralData::FluxCalc::errHigh%412381F202AE.attr preserve=no  public: Real {U} 
          Real errHigh;
          //## end SpectralData::FluxCalc::errHigh%412381F202AE.attr

          //## Attribute: photonValue%44980DCE02DA
          //## begin SpectralData::FluxCalc::photonValue%44980DCE02DA.attr preserve=no  public: Real {U} 
          Real photonValue;
          //## end SpectralData::FluxCalc::photonValue%44980DCE02DA.attr

          //## Attribute: photonLow%44980DFA01B5
          //## begin SpectralData::FluxCalc::photonLow%44980DFA01B5.attr preserve=no  public: Real {U} 
          Real photonLow;
          //## end SpectralData::FluxCalc::photonLow%44980DFA01B5.attr

          //## Attribute: photonHigh%44980E120290
          //## begin SpectralData::FluxCalc::photonHigh%44980E120290.attr preserve=no  public: Real {U} 
          Real photonHigh;
          //## end SpectralData::FluxCalc::photonHigh%44980E120290.attr

      public:
        // Additional Public Declarations
          //## begin SpectralData::FluxCalc%412381220124.public preserve=yes
          FluxCalc (Real val = .0, Real elow = .0, Real ehigh = .0,
                Real pval = .0, Real plow = .0, Real phigh = .0) 
            : value(val), errLow(elow), errHigh(ehigh),
              photonValue(pval), photonLow(plow), photonHigh(phigh) {}
          //## end SpectralData::FluxCalc%412381220124.public
      protected:
        // Additional Protected Declarations
          //## begin SpectralData::FluxCalc%412381220124.protected preserve=yes
          //## end SpectralData::FluxCalc%412381220124.protected

      private:
        // Additional Private Declarations
          //## begin SpectralData::FluxCalc%412381220124.private preserve=yes
          //## end SpectralData::FluxCalc%412381220124.private

      private: //## implementation
        // Additional Implementation Declarations
          //## begin SpectralData::FluxCalc%412381220124.implementation preserve=yes
          //## end SpectralData::FluxCalc%412381220124.implementation

    };

    //## begin SpectralData::FluxCalc%412381220124.postscript preserve=yes
    //## end SpectralData::FluxCalc%412381220124.postscript

    //## begin SpectralData::SpectralMemento%41C9D67E03E3.preface preserve=yes
    //## end SpectralData::SpectralMemento%41C9D67E03E3.preface

    //## Class: SpectralMemento%41C9D67E03E3
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    //## Uses: <unnamed>%41C9DAA60104;XSContainer::Memento { -> }

    class SpectralMemento : public XSContainer::Memento  //## Inherits: <unnamed>%41C9DA6D009D
    {
      //## begin SpectralData::SpectralMemento%41C9D67E03E3.initialDeclarations preserve=yes
      //## end SpectralData::SpectralMemento%41C9D67E03E3.initialDeclarations

      public:
        // Data Members for Class Attributes

          //## Attribute: dataGroup%41C9D8590228
          //## begin SpectralData::SpectralMemento::dataGroup%41C9D8590228.attr preserve=no  public: size_t {U} 
          size_t m_dataGroup;
          //## end SpectralData::SpectralMemento::dataGroup%41C9D8590228.attr

          //## Attribute: dataName%41C9D86102F0
          //## begin SpectralData::SpectralMemento::dataName%41C9D86102F0.attr preserve=no  public: string {U} 
          string m_dataName;
          //## end SpectralData::SpectralMemento::dataName%41C9D86102F0.attr

          //## Attribute: responses%41CB0CD301AD
          //## begin SpectralData::SpectralMemento::responses%41CB0CD301AD.attr preserve=no  public: std::vector<Response*> {U} 
          std::vector<Response*> m_responses;
          //## end SpectralData::SpectralMemento::responses%41CB0CD301AD.attr

        // Additional Public Declarations
          //## begin SpectralData::SpectralMemento%41C9D67E03E3.public preserve=yes
          //## end SpectralData::SpectralMemento%41C9D67E03E3.public

      protected:
        // Additional Protected Declarations
          //## begin SpectralData::SpectralMemento%41C9D67E03E3.protected preserve=yes
          //## end SpectralData::SpectralMemento%41C9D67E03E3.protected

      private:
        //## Assignment Operation (generated)
          SpectralMemento & operator=(const SpectralMemento &right);

        // Additional Private Declarations
          //## begin SpectralData::SpectralMemento%41C9D67E03E3.private preserve=yes
          //## end SpectralData::SpectralMemento%41C9D67E03E3.private

      private: //## implementation
        // Additional Implementation Declarations
          //## begin SpectralData::SpectralMemento%41C9D67E03E3.implementation preserve=yes
          //## end SpectralData::SpectralMemento%41C9D67E03E3.implementation

    };

    //## begin SpectralData::SpectralMemento%41C9D67E03E3.postscript preserve=yes
    //## end SpectralData::SpectralMemento%41C9D67E03E3.postscript

    //## Class: ChannelInfo%41DEF21802AB
    //## Category: XSModel::Data%36349D4100F3
    //## Subsystem: XSModel::Data%367691B49E40
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef struct { size_t m_firstChan; size_t m_startChan; size_t m_endChan; size_t m_detChans;} ChannelInfo;

    //## Constructors (specified)
      //## Operation: SpectralData%39B7CA540115
      SpectralData (DataSet* parent, size_t channels = 0, size_t rowNumber = 1, size_t sourceNums = 1);

    //## Destructor (generated)
      virtual ~SpectralData();


    //## Other Operations (specified)
      //## Operation: destroy%3A37CF1A0141
      //## Exceptions: ()
      void destroy () throw ();

      //## Operation: closeAncillaryFiles%3A393FC300B7
      virtual void closeAncillaryFiles ();

      //## Operation: renumber%3A75CF1D028A
      //	change spectrum number and the number of all the
      //	associated objects.
      void renumber (size_t newIndex);

      //## Operation: removeResponses%3AC2184500F5
      //## Exceptions: ()
      void removeResponses (size_t index = 0) throw ();

      //## Operation: detector%3BA265CF02B6
      Response* detector (size_t index) const;

      //## Operation: attachDetector%3BA265FE00F7
      void attachDetector (Response* value, size_t index = 0);

      //## Operation: setChannels%3BBC79C20263
      void setChannels (bool value, IntegerArray& range);

      //## Operation: sensitivity%3DE51FCD0086
      std::vector<RealArray> sensitivity () const;

      //## Operation: setBadChannels%3BBC7A2A0026
      bool setBadChannels ();

      //## Operation: setChannels%3BBCD71C02A4
      void setChannels (bool value, std::pair<Real,Real>& range);

      //## Operation: responseLoaded%3C20D8ED032C
      bool responseLoaded (size_t index = 0);

      //## Operation: setBackgroundSpectrum%3D46F9F40091
      void setBackgroundSpectrum (const RealArray& value, bool scaleCounts = false);

      //## Operation: debugPrint%3C3F5F7E0044
      void debugPrint (XSstream& s, const string& type) const;

      //## Operation: prepareForFit%3C3F602002DE
      void prepareForFit ();

      //## Operation: energyChannel%3CF4F20200A9
      //	return the energy from the Ebounds array(s)
      //	corresponding to the input channel number. The channel
      //	number is
      //	a non-const reference so the results of the last search
      //	can be reused.
      int energyChannel (const Real& energy, int& channel) const;

      //## Operation: channelEnergy%3CF4F4A001CA
      Real channelEnergy (size_t channel);

      //## Operation: simulateSpectrum%3D4584B30131
      //	Takes an input vector M*R vector and combines with
      //	background and correction.   This is randomized to
      //	produce a simulated spectrum and variance which are then
      //	stored in the class data member arrays.
      void simulateSpectrum (const RealArray& spectrum);

      //## Operation: setBackgroundVariance%3D46FA1B015A
      void setBackgroundVariance (const RealArray& value);

      //## Operation: setSpectrum%3D497D890031
      void setSpectrum (const RealArray& value, bool scaleCounts = false);

      //## Operation: simulateBackground%3D5153E20028
      //	Apply Poisson or Gaussian randomization to the
      //	background spectrum and variance.
      void simulateBackground ();

      //## Operation: computeTotals%3D6129CB026D
      void computeTotals ();

      //## Operation: energiesEqual%3D9371B303A6
      bool energiesEqual (SpectralData* right) const;

      //## Operation: attachUserDummy%3E5A95C40248
      void attachUserDummy (UserDummyResponse* dummyResponse, size_t index);

      //## Operation: removeUserDummy%3E5A9C900206
      bool removeUserDummy (size_t index);

      //## Operation: removeAllDummies%3E6D049E03A8
      bool removeAllDummies ();

      //## Operation: setNumberOfChannels%3E9D6B6501E2
      void setNumberOfChannels (size_t nChans);

      //## Operation: initializeFake%3ECA48EE03A6
      void initializeFake (const SpectralData* origSpectrum);

      //## Operation: spectrum%3EDBC033021D
      RealArray& spectrum ();

      //## Operation: getBackground%3EDCB74D01CB
      Background* getBackground ();

      //## Operation: isDummyrspMode2%3F5DDB5C02D7
      bool isDummyrspMode2 (size_t iDet = 0) const;

      //## Operation: reportNoticed%3FCCA7010135
      void reportNoticed () const;

      //## Operation: buildIndirectNotice%3FCCB27B0130
      void buildIndirectNotice (std::valarray<size_t>& indirectNotice) const;

      //## Operation: reportKeywords%3FCCB3CC00A2
      void reportKeywords () const;

      //## Operation: reportRates%3FCE43D301E6
      void reportRates () const;

      //## Operation: resetDetsDataGroupNums%3FE0AC7201E0
      void resetDetsDataGroupNums (size_t dataGroup);

      //## Operation: initializeFake%41C84D3701B1
      void initializeFake (const SpectralData::ChannelInfo& chanInfo);

      //## Operation: reinitFromBackground%41C84D80019D
      void reinitFromBackground ();

      //## Operation: CreateMemento%41CAFF0B0351
      void CreateMemento ();

      //## Operation: checkForPoisson%41D0472701BC
      bool checkForPoisson (const SpectralData* parentSpec = 0);

      //## Operation: SetMemento%41DD6C8602F1
      void SetMemento ();

      //## Operation: calcEffectiveAreas%421256C201D6
      void calcEffectiveAreas ();

      //## Operation: clearEffectiveAreas%4213A8310078
      void clearEffectiveAreas ();

      //## Operation: addToSpectrum%422C7900016D
      void addToSpectrum (const RealArray& addValue, bool scaleCounts = false);

      //## Operation: reduceNDets%4448EE39026F
      void reduceNDets (size_t newNDets);

      //## Operation: increaseNDets%4448EE720204
      void increaseNDets (size_t newNDets);

      //## Operation: reportPha%45F998080244
      void reportPha () const;

      //## Operation: reportGrouping%4603D589033C
      void reportGrouping () const;

      //## Operation: report%4603D5D1015B
      void report (bool orderByFile = true) const;

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: exposureTime%39B79BB60008
      Real exposureTime () const;
      void exposureTime (Real value);

      //## Attribute: correctionScale%39B79BCA019D
      Real correctionScale () const;
      void correctionScale (Real value);

      //## Attribute: channels%39B79CF20299
      size_t channels () const;
      void channels (size_t value);

      //## Attribute: startChan%39B79E0E024C
      size_t startChan () const;
      void startChan (size_t value);

      //## Attribute: endChan%39B79E1803AD
      size_t endChan () const;
      void endChan (size_t value);

      //## Attribute: telescope%39B7AA910312
      const string& telescope () const;
      void telescope (const string& value);

      //## Attribute: instrument%39B7AA950281
      const string& instrument () const;
      void instrument (const string& value);

      //## Attribute: channelType%39B7AA9A016F
      string channelType () const;
      void channelType (string value);

      //## Attribute: backgroundFile%39FDEDF402EC
      const string& backgroundFile () const;
      void backgroundFile (const string& value);

      //## Attribute: correctionFile%39FDEDF70389
      //	Name of the file stem from which the data were read
      //	(i.e. without the fits,pha,rmf,arf,bck,cor ...
      //	extension).
      const string& correctionFile () const;
      void correctionFile (const string& value);

      //## Attribute: spectrumNumber%3A01AA5300CF
      size_t spectrumNumber () const;
      void spectrumNumber (size_t value);

      //## Attribute: plotGroup%3A226D510301
      size_t plotGroup () const;
      void plotGroup (size_t value);

      //## Attribute: netFlux%3A2E74FA0248
      Real netFlux () const;
      void netFlux (Real value);

      //## Attribute: totalFlux%3A2E74E6028F
      Real totalFlux () const;
      void totalFlux (Real value);

      //## Attribute: netVariance%3A2E7509018D
      Real netVariance () const;
      void netVariance (Real value);

      //## Attribute: gqString%3AEF1D380034
      const CodeContainer& gqString () const;
      void gqString (const CodeContainer& value);

      //## Attribute: firstChan%3C6829F50377
      const size_t firstChan () const;
      void firstChan (size_t value);

      //## Attribute: rowNumber%3CBB198902FF
      size_t rowNumber () const;

      //## Attribute: spectrumIsZeroed%3EF222310200
      bool spectrumIsZeroed () const;

      //## Attribute: lastEqWidthCalc%3FDE2F940103
      const SpectralData::FluxCalc& lastEqWidthCalc () const;
      void lastEqWidthCalc (const SpectralData::FluxCalc& value);

      //## Attribute: backgroundChanged%4027B9A900EE
      const bool backgroundChanged () const;
      void backgroundChanged (bool value);

      //## Attribute: correctionChanged%4028F7B1030A
      const bool correctionChanged () const;
      void correctionChanged (bool value);

      //## Attribute: parent%419A1B080052
      const DataSet* parent () const;
      void parent (DataSet* value);

      //## Attribute: isPoisson%41D2F727019B
      bool isPoisson () const;
      void isPoisson (bool value);

      //## Attribute: effectiveAreas%4213A85F0364
      const RealArray& effectiveAreas () const;

      //## Attribute: chanEngWave%4B9964E5018B
      //	Plot x-axis setting which is needed here for purposes of
      //	evaluating ignore/notice.  chan = 0, energy = 1, wave =
      //	2 (The PlotTypes.h enumerators can't be seen from this
      //	library.)
      static void chanEngWave (int value);

      //## Attribute: engUnits%4B99661F033C
      //	Units conversion factor relative to keV, set from
      //	setplot handler and needed for ignore/notice.
      static void engUnits (Real value);

      //## Attribute: waveUnits%4B9966B9016D
      //	Units conversion factor relative to Angstroms, set from
      //	setplot handler and needed for ignore/notice.
      static void waveUnits (Real value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSModel::Data::<unnamed>%36C1E2A319B8
      //## Role: SpectralData::background%36C1E2A5DA68
      const Background* background () const;
      void background (Background* value);

      //## Association: XSModel::Data::<unnamed>%39F85DFF0328
      //## Role: SpectralData::correction%39F85E00022B
      const Correction* correction () const;
      void correction (Correction* value);

      //## Association: XSModel::Data::<unnamed>%3BA25B4B03CF
      //## Role: SpectralData::rawVariance%3BA25B4D0085
      //## Qualifier: index%3BA25B6600EF; size_t
      const RealArray& rawVariance () const;
      void setRawVariance (const RealArray& value);
      Real rawVariance (size_t index) const;
      void rawVariance (size_t index, Real value);

      //## Association: XSModel::Data::<unnamed>%3BA25D070082
      //## Role: SpectralData::noticedChannels%3BA25D0802CC
      //## Qualifier: index%3BA25D170145; size_t
      const BoolArray& noticedChannels () const;
      void setNoticedChannels (const BoolArray& value);
      bool noticedChannels (size_t index) const;
      void noticedChannels (size_t index, bool value);

      //## Association: XSModel::Data::<unnamed>%3BA25E5E035A
      //## Role: SpectralData::variance%3BA25E60030B
      //## Qualifier: index%3BA25E7601F3; size_t
      const RealArray& variance () const;
      void setVariance (const RealArray& value);
      Real variance (size_t index) const;
      void variance (size_t index, Real value);

      //## Association: XSModel::Data::<unnamed>%3BA25EB602B7
      //## Role: SpectralData::spectrum%3BA25EB90174
      //## Qualifier: index%3BA25ECF020A; size_t
      const RealArray& spectrum () const;
      Real spectrum (size_t index) const;
      void spectrum (size_t index, Real value);

      //## Association: XSModel::Data::Detector responses%3BA2634500A6
      //## Role: SpectralData::detector%3BA26345024E
      //## Qualifier: index%3BA26361039F; size_t
      const std::vector<Response*>& detector () const;
      void setDetector (const std::vector<Response*>& value);

      //## Association: XSModel::Data::<unnamed>%3C4446CE00EB
      //## Role: SpectralData::indirectNotice%3C4446CE028D
      const std::valarray< size_t >& indirectNotice () const;

      //## Association: XSModel::Data::<unnamed>%3C5180C9009E
      //## Role: SpectralData::areaScale%3C5180CA005B
      //## Qualifier: index%3C5180FE0243; size_t
      const RealArray& areaScale () const;
      void setAreaScale (const RealArray& value);
      Real areaScale (size_t index) const;
      void areaScale (size_t index, Real value);

      //## Association: XSModel::Data::<unnamed>%3D46F39501AF
      //## Role: SpectralData::backgroundScale%3D46F3960349
      //## Qualifier: index%3D46F3B40127; size_t
      const RealArray& backgroundScale () const;
      void setBackgroundScale (const RealArray& value);
      Real backgroundScale (size_t index) const;
      void backgroundScale (size_t index, Real value);

      //## Association: XSModel::Data::Quality%3DE52851012A
      //## Role: SpectralData::quality%3DE52851035B
      //## Qualifier: index%3DE5287A034D; size_t
      const IntegerArray& quality () const;
      void setQuality (const IntegerArray& value);
      int quality (size_t index) const;
      void quality (size_t index, int value);

      //## Association: XSModel::Data::Quality Input Vector%3DE5297C0116
      //## Role: SpectralData::qualityInfo%3DE5297D0114
      //## Qualifier: index%3DE529960225; size_t
      const IntegerArray& qualityInfo () const;
      void setQualityInfo (const IntegerArray& value);
      int qualityInfo (size_t index) const;
      void qualityInfo (size_t index, int value);

      //## Association: XSModel::Data::Grouping Input Vector%3DE529AD0175
      //## Role: SpectralData::groupingInfo%3DE529AE034E
      //## Qualifier: index%3DE529D300C5; size_t
      const IntegerArray& groupingInfo () const;
      void setGroupingInfo (const IntegerArray& value);
      int groupingInfo (size_t index) const;
      void groupingInfo (size_t index, int value);

      //## Association: XSModel::Data::Tmp resp storage%3E70A3AF031B
      //## Role: SpectralData::responseHooks  %3E70A3B10248
      //## Qualifier: index%3EE09C3C0276; size_t
      const Response* responseHooks (size_t index) const;

      //## Association: XSModel::Data::<unnamed>%402124CB0005
      //## Role: SpectralData::responseChanged%402124CE00E6
      //## Qualifier: index%40212609012E; size_t
      const std::vector<bool>& responseChanged () const;
      void setResponseChanged (const std::vector<bool>& value);
      bool responseChanged (size_t index) const;
      void responseChanged (size_t index, bool value);

      //## Association: XSModel::Data::<unnamed>%40A511AF022D
      //## Role: SpectralData::xflt%40A511B003B8
      //## Qualifier: key%40A511C90174; size_t
      const std::map<size_t, Real>& xflt () const;
      void setxflt (const std::map<size_t, Real>& value);
      Real xflt (size_t key) const;
      void xflt (size_t key, Real value);

      //## Association: XSModel::Data::<unnamed>%40FD655A02A0
      //## Role: SpectralData::arfChanged%40FD655F0103
      //## Qualifier: index%40FD65C20066; size_t
      const std::vector<bool>& arfChanged () const;
      void setArfChanged (const std::vector<bool>& value);
      bool arfChanged (size_t index) const;
      void arfChanged (size_t index, bool value);

      //## Association: XSModel::Data::<unnamed>%412383280353
      //## Role: SpectralData::lastModelFluxCalc%4123832C010D
      //## Qualifier: index%412383A10057; size_t
      const std::vector<FluxCalc>& lastModelFluxCalc () const;
      void setLastModelFluxCalc (const std::vector<FluxCalc>& value);
      const SpectralData::FluxCalc& lastModelFluxCalc (size_t index) const;
      void lastModelFluxCalc (size_t index, const SpectralData::FluxCalc& value);

      //## Association: XSModel::Data::<unnamed>%4123AA3A02D0
      //## Role: SpectralData::lastModelLuminCalc%4123AA3B0392
      //## Qualifier: index%4123AAAE029E; size_t
      const std::vector<FluxCalc>& lastModelLuminCalc () const;
      void setLastModelLuminCalc (const std::vector<FluxCalc>& value);
      const SpectralData::FluxCalc& lastModelLuminCalc (size_t index) const;
      void lastModelLuminCalc (size_t index, const SpectralData::FluxCalc& value);

  public:
    // Additional Public Declarations
      //## begin SpectralData%39AECD390243.public preserve=yes
      //## end SpectralData%39AECD390243.public

  protected:
    // Additional Protected Declarations
      //## begin SpectralData%39AECD390243.protected preserve=yes
      //## end SpectralData%39AECD390243.protected

  private:
    //## Constructors (generated)
      SpectralData(const SpectralData &right);

    //## Assignment Operation (generated)
      SpectralData & operator=(const SpectralData &right);

    // Additional Private Declarations
      //## begin SpectralData%39AECD390243.private preserve=yes
      //## end SpectralData%39AECD390243.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin SpectralData::exposureTime%39B79BB60008.attr preserve=no  public: Real {U} 0.
      Real m_exposureTime;
      //## end SpectralData::exposureTime%39B79BB60008.attr

      //## begin SpectralData::correctionScale%39B79BCA019D.attr preserve=no  public: Real {U} 0.
      Real m_correctionScale;
      //## end SpectralData::correctionScale%39B79BCA019D.attr

      //## begin SpectralData::channels%39B79CF20299.attr preserve=no  public: size_t {U} chans
      size_t m_channels;
      //## end SpectralData::channels%39B79CF20299.attr

      //## begin SpectralData::startChan%39B79E0E024C.attr preserve=no  public: size_t {U} 0
      size_t m_startChan;
      //## end SpectralData::startChan%39B79E0E024C.attr

      //## begin SpectralData::endChan%39B79E1803AD.attr preserve=no  public: size_t {U} 0
      size_t m_endChan;
      //## end SpectralData::endChan%39B79E1803AD.attr

      //## begin SpectralData::telescope%39B7AA910312.attr preserve=no  public: string {U} ""
      string m_telescope;
      //## end SpectralData::telescope%39B7AA910312.attr

      //## begin SpectralData::instrument%39B7AA950281.attr preserve=no  public: string {U} ""
      string m_instrument;
      //## end SpectralData::instrument%39B7AA950281.attr

      //## begin SpectralData::channelType%39B7AA9A016F.attr preserve=no  public: string {U} 
      string m_channelType;
      //## end SpectralData::channelType%39B7AA9A016F.attr

      //## begin SpectralData::backgroundFile%39FDEDF402EC.attr preserve=no  public: string {U} 
      string m_backgroundFile;
      //## end SpectralData::backgroundFile%39FDEDF402EC.attr

      //## begin SpectralData::correctionFile%39FDEDF70389.attr preserve=no  public: string {U} 
      string m_correctionFile;
      //## end SpectralData::correctionFile%39FDEDF70389.attr

      //## begin SpectralData::spectrumNumber%3A01AA5300CF.attr preserve=no  public: size_t {U} 1
      size_t m_spectrumNumber;
      //## end SpectralData::spectrumNumber%3A01AA5300CF.attr

      //## begin SpectralData::plotGroup%3A226D510301.attr preserve=no  public: size_t {U} 1
      size_t m_plotGroup;
      //## end SpectralData::plotGroup%3A226D510301.attr

      //## begin SpectralData::netFlux%3A2E74FA0248.attr preserve=no  public: Real {U} 
      Real m_netFlux;
      //## end SpectralData::netFlux%3A2E74FA0248.attr

      //## begin SpectralData::totalFlux%3A2E74E6028F.attr preserve=no  public: Real {U} 
      Real m_totalFlux;
      //## end SpectralData::totalFlux%3A2E74E6028F.attr

      //## begin SpectralData::netVariance%3A2E7509018D.attr preserve=no  public: Real {U} 
      Real m_netVariance;
      //## end SpectralData::netVariance%3A2E7509018D.attr

      //## begin SpectralData::gqString%3AEF1D380034.attr preserve=no  public: CodeContainer {U} 
      CodeContainer m_gqString;
      //## end SpectralData::gqString%3AEF1D380034.attr

      //## begin SpectralData::firstChan%3C6829F50377.attr preserve=no  public: size_t {U} 
      size_t m_firstChan;
      //## end SpectralData::firstChan%3C6829F50377.attr

      //## begin SpectralData::rowNumber%3CBB198902FF.attr preserve=no  public: size_t {U} 
      size_t m_rowNumber;
      //## end SpectralData::rowNumber%3CBB198902FF.attr

      //## begin SpectralData::spectrumIsZeroed%3EF222310200.attr preserve=no  public: bool {U} 
      bool m_spectrumIsZeroed;
      //## end SpectralData::spectrumIsZeroed%3EF222310200.attr

      //## begin SpectralData::lastEqWidthCalc%3FDE2F940103.attr preserve=no  public: SpectralData::FluxCalc {U} 
      SpectralData::FluxCalc m_lastEqWidthCalc;
      //## end SpectralData::lastEqWidthCalc%3FDE2F940103.attr

      //## begin SpectralData::backgroundChanged%4027B9A900EE.attr preserve=no  public: bool {U} 
      bool m_backgroundChanged;
      //## end SpectralData::backgroundChanged%4027B9A900EE.attr

      //## begin SpectralData::correctionChanged%4028F7B1030A.attr preserve=no  public: bool {U} 
      bool m_correctionChanged;
      //## end SpectralData::correctionChanged%4028F7B1030A.attr

      //## begin SpectralData::parent%419A1B080052.attr preserve=no  public: DataSet* {U} 
      DataSet* m_parent;
      //## end SpectralData::parent%419A1B080052.attr

      //## Attribute: memento%41C9D96D0092
      //## begin SpectralData::memento%41C9D96D0092.attr preserve=no  public: SpectralData::SpectralMemento* {U} 
      SpectralData::SpectralMemento* m_memento;
      //## end SpectralData::memento%41C9D96D0092.attr

      //## begin SpectralData::isPoisson%41D2F727019B.attr preserve=no  public: bool {U} 
      bool m_isPoisson;
      //## end SpectralData::isPoisson%41D2F727019B.attr

      //## begin SpectralData::effectiveAreas%4213A85F0364.attr preserve=no  public: RealArray {U} 
      RealArray m_effectiveAreas;
      //## end SpectralData::effectiveAreas%4213A85F0364.attr

      //## begin SpectralData::chanEngWave%4B9964E5018B.attr preserve=no  public: static int {U} 0
      static int s_chanEngWave;
      //## end SpectralData::chanEngWave%4B9964E5018B.attr

      //## begin SpectralData::engUnits%4B99661F033C.attr preserve=no  public: static Real {U} 1.0
      static Real s_engUnits;
      //## end SpectralData::engUnits%4B99661F033C.attr

      //## begin SpectralData::waveUnits%4B9966B9016D.attr preserve=no  public: static Real {U} 1.0
      static Real s_waveUnits;
      //## end SpectralData::waveUnits%4B9966B9016D.attr

    // Data Members for Associations

      //## Association: XSModel::Data::<unnamed>%36C1E2A319B8
      //## begin SpectralData::background%36C1E2A5DA68.role preserve=no  public: Background {1 -> 1RFHN}
      Background* m_background;
      //## end SpectralData::background%36C1E2A5DA68.role

      //## Association: XSModel::Data::<unnamed>%39F85DFF0328
      //## begin SpectralData::correction%39F85E00022B.role preserve=no  public: Correction { -> 1RFHN}
      Correction* m_correction;
      //## end SpectralData::correction%39F85E00022B.role

      //## Association: XSModel::Data::<unnamed>%3BA25B4B03CF
      //## begin SpectralData::rawVariance%3BA25B4D0085.role preserve=no  public: RealArray { -> 1RHN}
      RealArray m_rawVariance;
      //## end SpectralData::rawVariance%3BA25B4D0085.role

      //## Association: XSModel::Data::<unnamed>%3BA25D070082
      //## begin SpectralData::noticedChannels%3BA25D0802CC.role preserve=no  public: BoolArray { -> 1VHgN}
      BoolArray m_noticedChannels;
      //## end SpectralData::noticedChannels%3BA25D0802CC.role

      //## Association: XSModel::Data::<unnamed>%3BA25E5E035A
      //## begin SpectralData::variance%3BA25E60030B.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray m_variance;
      //## end SpectralData::variance%3BA25E60030B.role

      //## Association: XSModel::Data::<unnamed>%3BA25EB602B7
      //## begin SpectralData::spectrum%3BA25EB90174.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray m_spectrum;
      //## end SpectralData::spectrum%3BA25EB90174.role

      //## Association: XSModel::Data::Detector responses%3BA2634500A6
      //## begin SpectralData::detector%3BA26345024E.role preserve=no  public: Response { -> 1..nRFHgN}
      std::vector<Response*> m_detector;
      //## end SpectralData::detector%3BA26345024E.role

      //## Association: XSModel::Data::<unnamed>%3C4446CE00EB
      //## begin SpectralData::indirectNotice%3C4446CE028D.role preserve=no  public: std::valarray< size_t > { -> 1VHgN}
      std::valarray< size_t > m_indirectNotice;
      //## end SpectralData::indirectNotice%3C4446CE028D.role

      //## Association: XSModel::Data::<unnamed>%3C5180C9009E
      //## begin SpectralData::areaScale%3C5180CA005B.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray m_areaScale;
      //## end SpectralData::areaScale%3C5180CA005B.role

      //## Association: XSModel::Data::<unnamed>%3D46F39501AF
      //## begin SpectralData::backgroundScale%3D46F3960349.role preserve=no  public: RealArray { -> 1VHgN}
      RealArray m_backgroundScale;
      //## end SpectralData::backgroundScale%3D46F3960349.role

      //## Association: XSModel::Data::Quality%3DE52851012A
      //## begin SpectralData::quality%3DE52851035B.role preserve=no  public: IntegerArray { -> 1..nVHgN}
      IntegerArray m_quality;
      //## end SpectralData::quality%3DE52851035B.role

      //## Association: XSModel::Data::Quality Input Vector%3DE5297C0116
      //## begin SpectralData::qualityInfo%3DE5297D0114.role preserve=no  public: IntegerArray { -> 1..nVHgN}
      IntegerArray m_qualityInfo;
      //## end SpectralData::qualityInfo%3DE5297D0114.role

      //## Association: XSModel::Data::Grouping Input Vector%3DE529AD0175
      //## begin SpectralData::groupingInfo%3DE529AE034E.role preserve=no  public: IntegerArray { -> 1..nVHgN}
      IntegerArray m_groupingInfo;
      //## end SpectralData::groupingInfo%3DE529AE034E.role

      //## Association: XSModel::Data::Tmp resp storage%3E70A3AF031B
      //## begin SpectralData::responseHooks  %3E70A3B10248.role preserve=no  public: Response { -> 1..nRFHgN}
      std::vector<Response*> m_responseHooks;
      //## end SpectralData::responseHooks  %3E70A3B10248.role

      //## Association: XSModel::Data::<unnamed>%402124CB0005
      //## begin SpectralData::responseChanged%402124CE00E6.role preserve=no  public: bool { -> 1..nVHgN}
      std::vector<bool> m_responseChanged;
      //## end SpectralData::responseChanged%402124CE00E6.role

      //## Association: XSModel::Data::<unnamed>%40A511AF022D
      //## begin SpectralData::xflt%40A511B003B8.role preserve=no  public: Real { -> 1..nVHgN}
      std::map<size_t, Real> m_xflt;
      //## end SpectralData::xflt%40A511B003B8.role

      //## Association: XSModel::Data::<unnamed>%40FD655A02A0
      //## begin SpectralData::arfChanged%40FD655F0103.role preserve=no  public: bool { -> 1..nVHgN}
      std::vector<bool> m_arfChanged;
      //## end SpectralData::arfChanged%40FD655F0103.role

      //## Association: XSModel::Data::<unnamed>%412383280353
      //## begin SpectralData::lastModelFluxCalc%4123832C010D.role preserve=no  public: SpectralData::FluxCalc { -> 1..nVHgN}
      std::vector<FluxCalc> m_lastModelFluxCalc;
      //## end SpectralData::lastModelFluxCalc%4123832C010D.role

      //## Association: XSModel::Data::<unnamed>%4123AA3A02D0
      //## begin SpectralData::lastModelLuminCalc%4123AA3B0392.role preserve=no  public: SpectralData::FluxCalc { -> 1..nVHgN}
      std::vector<FluxCalc> m_lastModelLuminCalc;
      //## end SpectralData::lastModelLuminCalc%4123AA3B0392.role

    // Additional Implementation Declarations
      //## begin SpectralData%39AECD390243.implementation preserve=yes
      //## end SpectralData%39AECD390243.implementation

};

//## begin SpectralData%39AECD390243.postscript preserve=yes
//## end SpectralData%39AECD390243.postscript

// Class SpectralData::NoEnergyRange 

// Class SpectralData::FluxCalc 

// Class SpectralData::SpectralMemento 

// Class SpectralData 


//## Other Operations (inline)
inline RealArray& SpectralData::spectrum ()
{
  //## begin SpectralData::spectrum%3EDBC033021D.body preserve=yes
   return m_spectrum;
  //## end SpectralData::spectrum%3EDBC033021D.body
}

inline Background* SpectralData::getBackground ()
{
  //## begin SpectralData::getBackground%3EDCB74D01CB.body preserve=yes
   return m_background;
  //## end SpectralData::getBackground%3EDCB74D01CB.body
}

//## Get and Set Operations for Class Attributes (inline)

inline Real SpectralData::exposureTime () const
{
  //## begin SpectralData::exposureTime%39B79BB60008.get preserve=no
  return m_exposureTime;
  //## end SpectralData::exposureTime%39B79BB60008.get
}

inline void SpectralData::exposureTime (Real value)
{
  //## begin SpectralData::exposureTime%39B79BB60008.set preserve=no
  m_exposureTime = value;
  //## end SpectralData::exposureTime%39B79BB60008.set
}

inline Real SpectralData::correctionScale () const
{
  //## begin SpectralData::correctionScale%39B79BCA019D.get preserve=no
  return m_correctionScale;
  //## end SpectralData::correctionScale%39B79BCA019D.get
}

inline void SpectralData::correctionScale (Real value)
{
  //## begin SpectralData::correctionScale%39B79BCA019D.set preserve=no
  m_correctionScale = value;
  //## end SpectralData::correctionScale%39B79BCA019D.set
}

inline size_t SpectralData::channels () const
{
  //## begin SpectralData::channels%39B79CF20299.get preserve=no
  return m_channels;
  //## end SpectralData::channels%39B79CF20299.get
}

inline void SpectralData::channels (size_t value)
{
  //## begin SpectralData::channels%39B79CF20299.set preserve=no
  m_channels = value;
  //## end SpectralData::channels%39B79CF20299.set
}

inline size_t SpectralData::startChan () const
{
  //## begin SpectralData::startChan%39B79E0E024C.get preserve=no
  return m_startChan;
  //## end SpectralData::startChan%39B79E0E024C.get
}

inline void SpectralData::startChan (size_t value)
{
  //## begin SpectralData::startChan%39B79E0E024C.set preserve=no
  m_startChan = value;
  //## end SpectralData::startChan%39B79E0E024C.set
}

inline size_t SpectralData::endChan () const
{
  //## begin SpectralData::endChan%39B79E1803AD.get preserve=no
  return m_endChan;
  //## end SpectralData::endChan%39B79E1803AD.get
}

inline void SpectralData::endChan (size_t value)
{
  //## begin SpectralData::endChan%39B79E1803AD.set preserve=no
  m_endChan = value;
  //## end SpectralData::endChan%39B79E1803AD.set
}

inline const string& SpectralData::telescope () const
{
  //## begin SpectralData::telescope%39B7AA910312.get preserve=no
  return m_telescope;
  //## end SpectralData::telescope%39B7AA910312.get
}

inline void SpectralData::telescope (const string& value)
{
  //## begin SpectralData::telescope%39B7AA910312.set preserve=no
  m_telescope = value;
  //## end SpectralData::telescope%39B7AA910312.set
}

inline const string& SpectralData::instrument () const
{
  //## begin SpectralData::instrument%39B7AA950281.get preserve=no
  return m_instrument;
  //## end SpectralData::instrument%39B7AA950281.get
}

inline void SpectralData::instrument (const string& value)
{
  //## begin SpectralData::instrument%39B7AA950281.set preserve=no
  m_instrument = value;
  //## end SpectralData::instrument%39B7AA950281.set
}

inline string SpectralData::channelType () const
{
  //## begin SpectralData::channelType%39B7AA9A016F.get preserve=no
  return m_channelType;
  //## end SpectralData::channelType%39B7AA9A016F.get
}

inline void SpectralData::channelType (string value)
{
  //## begin SpectralData::channelType%39B7AA9A016F.set preserve=no
  m_channelType = value;
  //## end SpectralData::channelType%39B7AA9A016F.set
}

inline const string& SpectralData::backgroundFile () const
{
  //## begin SpectralData::backgroundFile%39FDEDF402EC.get preserve=no
  return m_backgroundFile;
  //## end SpectralData::backgroundFile%39FDEDF402EC.get
}

inline void SpectralData::backgroundFile (const string& value)
{
  //## begin SpectralData::backgroundFile%39FDEDF402EC.set preserve=no
  m_backgroundFile = value;
  //## end SpectralData::backgroundFile%39FDEDF402EC.set
}

inline const string& SpectralData::correctionFile () const
{
  //## begin SpectralData::correctionFile%39FDEDF70389.get preserve=no
  return m_correctionFile;
  //## end SpectralData::correctionFile%39FDEDF70389.get
}

inline void SpectralData::correctionFile (const string& value)
{
  //## begin SpectralData::correctionFile%39FDEDF70389.set preserve=no
  m_correctionFile = value;
  //## end SpectralData::correctionFile%39FDEDF70389.set
}

inline size_t SpectralData::spectrumNumber () const
{
  //## begin SpectralData::spectrumNumber%3A01AA5300CF.get preserve=no
  return m_spectrumNumber;
  //## end SpectralData::spectrumNumber%3A01AA5300CF.get
}

inline void SpectralData::spectrumNumber (size_t value)
{
  //## begin SpectralData::spectrumNumber%3A01AA5300CF.set preserve=no
  m_spectrumNumber = value;
  //## end SpectralData::spectrumNumber%3A01AA5300CF.set
}

inline size_t SpectralData::plotGroup () const
{
  //## begin SpectralData::plotGroup%3A226D510301.get preserve=no
  return m_plotGroup;
  //## end SpectralData::plotGroup%3A226D510301.get
}

inline void SpectralData::plotGroup (size_t value)
{
  //## begin SpectralData::plotGroup%3A226D510301.set preserve=no
  m_plotGroup = value;
  //## end SpectralData::plotGroup%3A226D510301.set
}

inline Real SpectralData::netFlux () const
{
  //## begin SpectralData::netFlux%3A2E74FA0248.get preserve=no
  return m_netFlux;
  //## end SpectralData::netFlux%3A2E74FA0248.get
}

inline void SpectralData::netFlux (Real value)
{
  //## begin SpectralData::netFlux%3A2E74FA0248.set preserve=no
  m_netFlux = value;
  //## end SpectralData::netFlux%3A2E74FA0248.set
}

inline Real SpectralData::totalFlux () const
{
  //## begin SpectralData::totalFlux%3A2E74E6028F.get preserve=no
  return m_totalFlux;
  //## end SpectralData::totalFlux%3A2E74E6028F.get
}

inline void SpectralData::totalFlux (Real value)
{
  //## begin SpectralData::totalFlux%3A2E74E6028F.set preserve=no
  m_totalFlux = value;
  //## end SpectralData::totalFlux%3A2E74E6028F.set
}

inline Real SpectralData::netVariance () const
{
  //## begin SpectralData::netVariance%3A2E7509018D.get preserve=no
  return m_netVariance;
  //## end SpectralData::netVariance%3A2E7509018D.get
}

inline void SpectralData::netVariance (Real value)
{
  //## begin SpectralData::netVariance%3A2E7509018D.set preserve=no
  m_netVariance = value;
  //## end SpectralData::netVariance%3A2E7509018D.set
}

inline const CodeContainer& SpectralData::gqString () const
{
  //## begin SpectralData::gqString%3AEF1D380034.get preserve=no
  return m_gqString;
  //## end SpectralData::gqString%3AEF1D380034.get
}

inline void SpectralData::gqString (const CodeContainer& value)
{
  //## begin SpectralData::gqString%3AEF1D380034.set preserve=no
  m_gqString = value;
  //## end SpectralData::gqString%3AEF1D380034.set
}

inline const size_t SpectralData::firstChan () const
{
  //## begin SpectralData::firstChan%3C6829F50377.get preserve=no
  return m_firstChan;
  //## end SpectralData::firstChan%3C6829F50377.get
}

inline void SpectralData::firstChan (size_t value)
{
  //## begin SpectralData::firstChan%3C6829F50377.set preserve=no
  m_firstChan = value;
  //## end SpectralData::firstChan%3C6829F50377.set
}

inline size_t SpectralData::rowNumber () const
{
  //## begin SpectralData::rowNumber%3CBB198902FF.get preserve=no
  return m_rowNumber;
  //## end SpectralData::rowNumber%3CBB198902FF.get
}

inline bool SpectralData::spectrumIsZeroed () const
{
  //## begin SpectralData::spectrumIsZeroed%3EF222310200.get preserve=no
  return m_spectrumIsZeroed;
  //## end SpectralData::spectrumIsZeroed%3EF222310200.get
}

inline const SpectralData::FluxCalc& SpectralData::lastEqWidthCalc () const
{
  //## begin SpectralData::lastEqWidthCalc%3FDE2F940103.get preserve=no
  return m_lastEqWidthCalc;
  //## end SpectralData::lastEqWidthCalc%3FDE2F940103.get
}

inline void SpectralData::lastEqWidthCalc (const SpectralData::FluxCalc& value)
{
  //## begin SpectralData::lastEqWidthCalc%3FDE2F940103.set preserve=no
  m_lastEqWidthCalc = value;
  //## end SpectralData::lastEqWidthCalc%3FDE2F940103.set
}

inline const bool SpectralData::backgroundChanged () const
{
  //## begin SpectralData::backgroundChanged%4027B9A900EE.get preserve=no
  return m_backgroundChanged;
  //## end SpectralData::backgroundChanged%4027B9A900EE.get
}

inline void SpectralData::backgroundChanged (bool value)
{
  //## begin SpectralData::backgroundChanged%4027B9A900EE.set preserve=no
  m_backgroundChanged = value;
  //## end SpectralData::backgroundChanged%4027B9A900EE.set
}

inline const bool SpectralData::correctionChanged () const
{
  //## begin SpectralData::correctionChanged%4028F7B1030A.get preserve=no
  return m_correctionChanged;
  //## end SpectralData::correctionChanged%4028F7B1030A.get
}

inline void SpectralData::correctionChanged (bool value)
{
  //## begin SpectralData::correctionChanged%4028F7B1030A.set preserve=no
  m_correctionChanged = value;
  //## end SpectralData::correctionChanged%4028F7B1030A.set
}

inline const DataSet* SpectralData::parent () const
{
  //## begin SpectralData::parent%419A1B080052.get preserve=no
  return m_parent;
  //## end SpectralData::parent%419A1B080052.get
}

inline void SpectralData::parent (DataSet* value)
{
  //## begin SpectralData::parent%419A1B080052.set preserve=no
  m_parent = value;
  //## end SpectralData::parent%419A1B080052.set
}

inline bool SpectralData::isPoisson () const
{
  //## begin SpectralData::isPoisson%41D2F727019B.get preserve=no
  return m_isPoisson;
  //## end SpectralData::isPoisson%41D2F727019B.get
}

inline void SpectralData::isPoisson (bool value)
{
  //## begin SpectralData::isPoisson%41D2F727019B.set preserve=no
  m_isPoisson = value;
  //## end SpectralData::isPoisson%41D2F727019B.set
}

inline const RealArray& SpectralData::effectiveAreas () const
{
  //## begin SpectralData::effectiveAreas%4213A85F0364.get preserve=no
  return m_effectiveAreas;
  //## end SpectralData::effectiveAreas%4213A85F0364.get
}

inline void SpectralData::chanEngWave (int value)
{
  //## begin SpectralData::chanEngWave%4B9964E5018B.set preserve=no
  s_chanEngWave = value;
  //## end SpectralData::chanEngWave%4B9964E5018B.set
}

inline void SpectralData::engUnits (Real value)
{
  //## begin SpectralData::engUnits%4B99661F033C.set preserve=no
  s_engUnits = value;
  //## end SpectralData::engUnits%4B99661F033C.set
}

inline void SpectralData::waveUnits (Real value)
{
  //## begin SpectralData::waveUnits%4B9966B9016D.set preserve=no
  s_waveUnits = value;
  //## end SpectralData::waveUnits%4B9966B9016D.set
}

//## Get and Set Operations for Associations (inline)

inline const Background* SpectralData::background () const
{
  //## begin SpectralData::background%36C1E2A5DA68.get preserve=no
  return m_background;
  //## end SpectralData::background%36C1E2A5DA68.get
}

inline const Correction* SpectralData::correction () const
{
  //## begin SpectralData::correction%39F85E00022B.get preserve=no
  return m_correction;
  //## end SpectralData::correction%39F85E00022B.get
}

inline const RealArray& SpectralData::rawVariance () const
{
  //## begin SpectralData::rawVariance%3BA25B4D0085.get preserve=no
  return m_rawVariance;
  //## end SpectralData::rawVariance%3BA25B4D0085.get
}

inline void SpectralData::setRawVariance (const RealArray& value)
{
  //## begin SpectralData::setRawVariance%3BA25B4D0085.set preserve=yes
  size_t N(value.size());
  if (m_rawVariance.size() != N) m_rawVariance.resize(N);
  m_rawVariance = value;
  //## end SpectralData::setRawVariance%3BA25B4D0085.set
}

inline Real SpectralData::rawVariance (size_t index) const
{
  //## begin SpectralData::rawVariance%3BA25B4D0085.qualget preserve=no
  return m_rawVariance[index];
  //## end SpectralData::rawVariance%3BA25B4D0085.qualget
}

inline void SpectralData::rawVariance (size_t index, Real value)
{
  //## begin SpectralData::rawVariance%3BA25B4D0085.qualset preserve=no
  m_rawVariance[index] = value;
  //## end SpectralData::rawVariance%3BA25B4D0085.qualset
}

inline const BoolArray& SpectralData::noticedChannels () const
{
  //## begin SpectralData::noticedChannels%3BA25D0802CC.get preserve=no
  return m_noticedChannels;
  //## end SpectralData::noticedChannels%3BA25D0802CC.get
}

inline void SpectralData::setNoticedChannels (const BoolArray& value)
{
  //## begin SpectralData::setNoticedChannels%3BA25D0802CC.set preserve=no
  m_noticedChannels = value;
  //## end SpectralData::setNoticedChannels%3BA25D0802CC.set
}

inline bool SpectralData::noticedChannels (size_t index) const
{
  //## begin SpectralData::noticedChannels%3BA25D0802CC.qualget preserve=no
  return m_noticedChannels[index];
  //## end SpectralData::noticedChannels%3BA25D0802CC.qualget
}

inline void SpectralData::noticedChannels (size_t index, bool value)
{
  //## begin SpectralData::noticedChannels%3BA25D0802CC.qualset preserve=no
  m_noticedChannels[index] = value;
  //## end SpectralData::noticedChannels%3BA25D0802CC.qualset
}

inline const RealArray& SpectralData::variance () const
{
  //## begin SpectralData::variance%3BA25E60030B.get preserve=no
  return m_variance;
  //## end SpectralData::variance%3BA25E60030B.get
}

inline void SpectralData::setVariance (const RealArray& value)
{
  //## begin SpectralData::setVariance%3BA25E60030B.set preserve=yes
  m_variance.resize(value.size());
  m_variance = value;
  //## end SpectralData::setVariance%3BA25E60030B.set
}

inline Real SpectralData::variance (size_t index) const
{
  //## begin SpectralData::variance%3BA25E60030B.qualget preserve=no
  return m_variance[index];
  //## end SpectralData::variance%3BA25E60030B.qualget
}

inline void SpectralData::variance (size_t index, Real value)
{
  //## begin SpectralData::variance%3BA25E60030B.qualset preserve=no
  m_variance[index] = value;
  //## end SpectralData::variance%3BA25E60030B.qualset
}

inline const RealArray& SpectralData::spectrum () const
{
  //## begin SpectralData::spectrum%3BA25EB90174.get preserve=no
  return m_spectrum;
  //## end SpectralData::spectrum%3BA25EB90174.get
}

inline Real SpectralData::spectrum (size_t index) const
{
  //## begin SpectralData::spectrum%3BA25EB90174.qualget preserve=no
  return m_spectrum[index];
  //## end SpectralData::spectrum%3BA25EB90174.qualget
}

inline void SpectralData::spectrum (size_t index, Real value)
{
  //## begin SpectralData::spectrum%3BA25EB90174.qualset preserve=no
  m_spectrum[index] = value;
  //## end SpectralData::spectrum%3BA25EB90174.qualset
}

inline const std::vector<Response*>& SpectralData::detector () const
{
  //## begin SpectralData::detector%3BA26345024E.get preserve=no
  return m_detector;
  //## end SpectralData::detector%3BA26345024E.get
}

inline void SpectralData::setDetector (const std::vector<Response*>& value)
{
  //## begin SpectralData::setDetector%3BA26345024E.set preserve=no
  m_detector = value;
  //## end SpectralData::setDetector%3BA26345024E.set
}

inline const std::valarray< size_t >& SpectralData::indirectNotice () const
{
  //## begin SpectralData::indirectNotice%3C4446CE028D.get preserve=no
  return m_indirectNotice;
  //## end SpectralData::indirectNotice%3C4446CE028D.get
}

inline const RealArray& SpectralData::areaScale () const
{
  //## begin SpectralData::areaScale%3C5180CA005B.get preserve=no
  return m_areaScale;
  //## end SpectralData::areaScale%3C5180CA005B.get
}

inline void SpectralData::setAreaScale (const RealArray& value)
{
  //## begin SpectralData::setAreaScale%3C5180CA005B.set preserve=yes
  m_areaScale.resize(value.size());
  m_areaScale = value;
  //## end SpectralData::setAreaScale%3C5180CA005B.set
}

inline Real SpectralData::areaScale (size_t index) const
{
  //## begin SpectralData::areaScale%3C5180CA005B.qualget preserve=no
  return m_areaScale[index];
  //## end SpectralData::areaScale%3C5180CA005B.qualget
}

inline void SpectralData::areaScale (size_t index, Real value)
{
  //## begin SpectralData::areaScale%3C5180CA005B.qualset preserve=no
  m_areaScale[index] = value;
  //## end SpectralData::areaScale%3C5180CA005B.qualset
}

inline const RealArray& SpectralData::backgroundScale () const
{
  //## begin SpectralData::backgroundScale%3D46F3960349.get preserve=no
  return m_backgroundScale;
  //## end SpectralData::backgroundScale%3D46F3960349.get
}

inline void SpectralData::setBackgroundScale (const RealArray& value)
{
  //## begin SpectralData::setBackgroundScale%3D46F3960349.set preserve=yes
  m_backgroundScale.resize(value.size());
  m_backgroundScale = value;
  //## end SpectralData::setBackgroundScale%3D46F3960349.set
}

inline Real SpectralData::backgroundScale (size_t index) const
{
  //## begin SpectralData::backgroundScale%3D46F3960349.qualget preserve=no
  return m_backgroundScale[index];
  //## end SpectralData::backgroundScale%3D46F3960349.qualget
}

inline void SpectralData::backgroundScale (size_t index, Real value)
{
  //## begin SpectralData::backgroundScale%3D46F3960349.qualset preserve=no
  m_backgroundScale[index] = value;
  //## end SpectralData::backgroundScale%3D46F3960349.qualset
}

inline const IntegerArray& SpectralData::quality () const
{
  //## begin SpectralData::quality%3DE52851035B.get preserve=no
  return m_quality;
  //## end SpectralData::quality%3DE52851035B.get
}

inline void SpectralData::setQuality (const IntegerArray& value)
{
  //## begin SpectralData::setQuality%3DE52851035B.set preserve=no
  m_quality = value;
  //## end SpectralData::setQuality%3DE52851035B.set
}

inline int SpectralData::quality (size_t index) const
{
  //## begin SpectralData::quality%3DE52851035B.qualget preserve=no
  return m_quality[index];
  //## end SpectralData::quality%3DE52851035B.qualget
}

inline void SpectralData::quality (size_t index, int value)
{
  //## begin SpectralData::quality%3DE52851035B.qualset preserve=no
  m_quality[index] = value;
  //## end SpectralData::quality%3DE52851035B.qualset
}

inline const IntegerArray& SpectralData::qualityInfo () const
{
  //## begin SpectralData::qualityInfo%3DE5297D0114.get preserve=no
  return m_qualityInfo;
  //## end SpectralData::qualityInfo%3DE5297D0114.get
}

inline void SpectralData::setQualityInfo (const IntegerArray& value)
{
  //## begin SpectralData::setQualityInfo%3DE5297D0114.set preserve=no
  m_qualityInfo = value;
  //## end SpectralData::setQualityInfo%3DE5297D0114.set
}

inline int SpectralData::qualityInfo (size_t index) const
{
  //## begin SpectralData::qualityInfo%3DE5297D0114.qualget preserve=no
  return m_qualityInfo[index];
  //## end SpectralData::qualityInfo%3DE5297D0114.qualget
}

inline void SpectralData::qualityInfo (size_t index, int value)
{
  //## begin SpectralData::qualityInfo%3DE5297D0114.qualset preserve=no
  m_qualityInfo[index] = value;
  //## end SpectralData::qualityInfo%3DE5297D0114.qualset
}

inline const IntegerArray& SpectralData::groupingInfo () const
{
  //## begin SpectralData::groupingInfo%3DE529AE034E.get preserve=no
  return m_groupingInfo;
  //## end SpectralData::groupingInfo%3DE529AE034E.get
}

inline void SpectralData::setGroupingInfo (const IntegerArray& value)
{
  //## begin SpectralData::setGroupingInfo%3DE529AE034E.set preserve=no
  m_groupingInfo = value;
  //## end SpectralData::setGroupingInfo%3DE529AE034E.set
}

inline int SpectralData::groupingInfo (size_t index) const
{
  //## begin SpectralData::groupingInfo%3DE529AE034E.qualget preserve=no
  return m_groupingInfo[index];
  //## end SpectralData::groupingInfo%3DE529AE034E.qualget
}

inline void SpectralData::groupingInfo (size_t index, int value)
{
  //## begin SpectralData::groupingInfo%3DE529AE034E.qualset preserve=no
  m_groupingInfo[index] = value;
  //## end SpectralData::groupingInfo%3DE529AE034E.qualset
}

inline const Response* SpectralData::responseHooks (size_t index) const
{
  //## begin SpectralData::responseHooks%3E70A3B10248.qualget preserve=no
  return m_responseHooks[index];
  //## end SpectralData::responseHooks%3E70A3B10248.qualget
}

inline const std::vector<bool>& SpectralData::responseChanged () const
{
  //## begin SpectralData::responseChanged%402124CE00E6.get preserve=no
  return m_responseChanged;
  //## end SpectralData::responseChanged%402124CE00E6.get
}

inline void SpectralData::setResponseChanged (const std::vector<bool>& value)
{
  //## begin SpectralData::setResponseChanged%402124CE00E6.set preserve=no
  m_responseChanged = value;
  //## end SpectralData::setResponseChanged%402124CE00E6.set
}

inline bool SpectralData::responseChanged (size_t index) const
{
  //## begin SpectralData::responseChanged%402124CE00E6.qualget preserve=no
  return m_responseChanged[index];
  //## end SpectralData::responseChanged%402124CE00E6.qualget
}

inline void SpectralData::responseChanged (size_t index, bool value)
{
  //## begin SpectralData::responseChanged%402124CE00E6.qualset preserve=no
  m_responseChanged[index] = value;
  //## end SpectralData::responseChanged%402124CE00E6.qualset
}

inline const std::map<size_t, Real>& SpectralData::xflt () const
{
  //## begin SpectralData::xflt%40A511B003B8.get preserve=no
  return m_xflt;
  //## end SpectralData::xflt%40A511B003B8.get
}

inline void SpectralData::setxflt (const std::map<size_t, Real>& value)
{
  //## begin SpectralData::setxflt%40A511B003B8.set preserve=no
  m_xflt = value;
  //## end SpectralData::setxflt%40A511B003B8.set
}

inline Real SpectralData::xflt (size_t key) const
{
  //## begin SpectralData::xflt%40A511B003B8.qualget preserve=yes
    using namespace std;

    map<size_t, Real>::const_iterator match = m_xflt.find(key);

    if(match != m_xflt.end()) 
	return match->second;
    else
	return -9999999;
  //## end SpectralData::xflt%40A511B003B8.qualget
}

inline void SpectralData::xflt (size_t key, Real value)
{
  //## begin SpectralData::xflt%40A511B003B8.qualset preserve=no
  m_xflt[key] = value;
  //## end SpectralData::xflt%40A511B003B8.qualset
}

inline const std::vector<bool>& SpectralData::arfChanged () const
{
  //## begin SpectralData::arfChanged%40FD655F0103.get preserve=no
  return m_arfChanged;
  //## end SpectralData::arfChanged%40FD655F0103.get
}

inline void SpectralData::setArfChanged (const std::vector<bool>& value)
{
  //## begin SpectralData::setArfChanged%40FD655F0103.set preserve=no
  m_arfChanged = value;
  //## end SpectralData::setArfChanged%40FD655F0103.set
}

inline bool SpectralData::arfChanged (size_t index) const
{
  //## begin SpectralData::arfChanged%40FD655F0103.qualget preserve=no
  return m_arfChanged[index];
  //## end SpectralData::arfChanged%40FD655F0103.qualget
}

inline void SpectralData::arfChanged (size_t index, bool value)
{
  //## begin SpectralData::arfChanged%40FD655F0103.qualset preserve=no
  m_arfChanged[index] = value;
  //## end SpectralData::arfChanged%40FD655F0103.qualset
}

inline const std::vector<SpectralData::FluxCalc>& SpectralData::lastModelFluxCalc () const
{
  //## begin SpectralData::lastModelFluxCalc%4123832C010D.get preserve=no
  return m_lastModelFluxCalc;
  //## end SpectralData::lastModelFluxCalc%4123832C010D.get
}

inline void SpectralData::setLastModelFluxCalc (const std::vector<SpectralData::FluxCalc>& value)
{
  //## begin SpectralData::setLastModelFluxCalc%4123832C010D.set preserve=no
  m_lastModelFluxCalc = value;
  //## end SpectralData::setLastModelFluxCalc%4123832C010D.set
}

inline const SpectralData::FluxCalc& SpectralData::lastModelFluxCalc (size_t index) const
{
  //## begin SpectralData::lastModelFluxCalc%4123832C010D.qualget preserve=no
  return m_lastModelFluxCalc[index];
  //## end SpectralData::lastModelFluxCalc%4123832C010D.qualget
}

inline void SpectralData::lastModelFluxCalc (size_t index, const SpectralData::FluxCalc& value)
{
  //## begin SpectralData::lastModelFluxCalc%4123832C010D.qualset preserve=no
  m_lastModelFluxCalc[index] = value;
  //## end SpectralData::lastModelFluxCalc%4123832C010D.qualset
}

inline const std::vector<SpectralData::FluxCalc>& SpectralData::lastModelLuminCalc () const
{
  //## begin SpectralData::lastModelLuminCalc%4123AA3B0392.get preserve=no
  return m_lastModelLuminCalc;
  //## end SpectralData::lastModelLuminCalc%4123AA3B0392.get
}

inline void SpectralData::setLastModelLuminCalc (const std::vector<SpectralData::FluxCalc>& value)
{
  //## begin SpectralData::setLastModelLuminCalc%4123AA3B0392.set preserve=no
  m_lastModelLuminCalc = value;
  //## end SpectralData::setLastModelLuminCalc%4123AA3B0392.set
}

inline const SpectralData::FluxCalc& SpectralData::lastModelLuminCalc (size_t index) const
{
  //## begin SpectralData::lastModelLuminCalc%4123AA3B0392.qualget preserve=no
  return m_lastModelLuminCalc[index];
  //## end SpectralData::lastModelLuminCalc%4123AA3B0392.qualget
}

inline void SpectralData::lastModelLuminCalc (size_t index, const SpectralData::FluxCalc& value)
{
  //## begin SpectralData::lastModelLuminCalc%4123AA3B0392.qualset preserve=no
  m_lastModelLuminCalc[index] = value;
  //## end SpectralData::lastModelLuminCalc%4123AA3B0392.qualset
}

//## begin module%39AECD940183.epilog preserve=yes
//## end module%39AECD940183.epilog


#endif
